diff --git a/oflog/include/dcmtk/oflog/ndc.h b/oflog/include/dcmtk/oflog/ndc.h
index 57ca206..d06f3e9 100644
--- a/oflog/include/dcmtk/oflog/ndc.h
+++ b/oflog/include/dcmtk/oflog/ndc.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    ndc.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,38 +19,28 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-/** @file
+/** @file 
  * This header defined the NDC class.
  */
 
-#ifndef DCMTK__LO4CPLUS_NDC_HEADER_
-#define DCMTK__LO4CPLUS_NDC_HEADER_
+#ifndef _LO4CPLUS_NDC_HEADER_
+#define _LO4CPLUS_NDC_HEADER_
 
 #include "dcmtk/oflog/config.h"
-#include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/helpers/lloguser.h"
-#include "dcmtk/oflog/helpers/threads.h"
-
-//#include <map>
-//#include <stack>
-#include "dcmtk/ofstd/ofstack.h"
 
-#if (defined(__MWERKS__) && defined(__MACOS__))
-using STD_NAMESPACE size_t;
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
 #endif
 
+#include "dcmtk/oflog/tstring.h"
+#include "dcmtk/ofstd/ofvector.h"
+
 
 namespace dcmtk {
 namespace log4cplus {
     // Forward declarations
-    class NDC;
     struct DiagnosticContext;
-    typedef OFStack<DiagnosticContext> DiagnosticContextStack;
-
-#if defined (_MSC_VER)
-    DCMTK_LOG4CPLUS_EXPORT NDC& getNDC();
-#endif
-
+    typedef OFVector<DiagnosticContext> DiagnosticContextStack;
 
     /**
      * The NDC class implements <i>nested diagnostic contexts</i> as
@@ -88,22 +79,23 @@ namespace log4cplus {
      *   <li>When leaving a context, call <code>getNDC().pop()</code>.
      *
      *   <li><b>When exiting a thread make sure to call {@link #remove
-     *   NDC.remove()}</b>.
+     *   NDC.remove()}</b>.  
      * </ul>
-     *
+     *                                          
      * There is no penalty for forgetting to match each
      * <code>push</code> operation with a corresponding <code>pop</code>,
      * except the obvious mismatch between the real application context
      * and the context set in the NDC.  Use of the {@link NDCContextCreator}
      * class can automate this process and make your code exception-safe.
      *
-     * If configured to do so, {@link dcmtk::log4cplus::PatternLayout} and {@link
-     * dcmtk::log4cplus::TTCCLayout} instances automatically retrieve the nested diagnostic
-     * context for the current thread without any user intervention.
-     * Hence, even if a server is serving multiple clients
-     * simultaneously, the logs emanating from the same code (belonging to
-     * the same logger) can still be distinguished because each client
-     * request will have a different NDC tag.
+     * If configured to do so, {@link log4cplus::PatternLayout} and
+     * {@link log4cplus::TTCCLayout} instances automatically retrieve
+     * the nested diagnostic context for the current thread without
+     * any user intervention.  Hence, even if a server is serving
+     * multiple clients simultaneously, the logs emanating from the
+     * same code (belonging to the same logger) can still be
+     * distinguished because each client request will have a different
+     * NDC tag.
      *
      * Heavy duty systems should call the {@link #remove} method when
      * leaving the run method of a thread. This ensures that the memory
@@ -115,7 +107,8 @@ namespace log4cplus {
      * #cloneStack cloneStack} method and pass the reference to any other
      * thread, in particular to a child.
      */
-    class DCMTK_LOG4CPLUS_EXPORT NDC : protected helpers::LogLogUser {
+    class DCMTK_LOG4CPLUS_EXPORT NDC
+    {
     public:
         /**
          * Clear any nested diagnostic information if any. This method is
@@ -137,10 +130,10 @@ namespace log4cplus {
          *
          * The child thread uses the {@link #inherit inherit} method to
          * inherit the parent's diagnostic context.
-         *
+         *                                        
          * @return Stack A clone of the current thread's  diagnostic context.
          */
-        DiagnosticContextStack cloneStack();
+        DiagnosticContextStack cloneStack() const;
 
         /**
          * Inherit the diagnostic context of another thread.
@@ -161,27 +154,37 @@ namespace log4cplus {
         /**
          * Used when printing the diagnostic context.
          */
-        tstring get();
+        log4cplus::tstring const & get() const;
 
         /**
          * Get the current nesting depth of this diagnostic context.
          *
          * @see #setMaxDepth
          */
-        size_t getDepth();
+        size_t getDepth() const;
 
         /**
          * Clients should call this method before leaving a diagnostic
          * context.
          *
          * The returned value is the value that was pushed last. If no
-         * context is available, then the empty string "" is returned.
+         * context is available, then the empty string "" is
+         * returned. If each call to push() is paired with a call to
+         * pop() (even in presence of thrown exceptions), the last
+         * pop() call frees the memory used by NDC for this
+         * thread. Otherwise, remove() must be called at the end of
+         * the thread to free the memory used by NDC for the thread.
          *
          * @return String The innermost diagnostic context.
          *
-         * @see NDCContextCreator
+         * @see NDCContextCreator, remove(), push()
+         */
+        log4cplus::tstring pop();
+
+        /**
+         * Same as pop() but without the return value.
          */
-        tstring pop();
+        void pop_void ();
 
         /**
          * Looks at the last diagnostic context at the top of this NDC
@@ -189,35 +192,36 @@ namespace log4cplus {
          *
          * The returned value is the value that was pushed last. If no
          * context is available, then the empty string "" is returned.
-         *
+         *                          
          * @return String The innermost diagnostic context.
          */
-        tstring peek();
+        log4cplus::tstring const & peek() const;
 
         /**
          * Push new diagnostic context information for the current thread.
          *
          * The contents of the <code>message</code> parameter is
-         * determined solely by the client.
-         *
-         * Please note that the calling thread should either call {@link #pop}
-         * once for each call to this method or call {@link #remove} before
-         * exiting. Otherwise, a small amount of memory will be leaked.
+         * determined solely by the client. Each call to push() should
+         * be paired with a call to pop().
          *
          * @param message The new diagnostic context information.
          *
-         * @see NDCContextCreator
+         * @see NDCContextCreator, pop(), remove()
          */
-        void push(const tstring& message);
+        void push(const log4cplus::tstring& message);
+        void push(tchar const * message);
 
         /**
          * Remove the diagnostic context for this thread.
          *
          * Each thread that created a diagnostic context by calling
-         * {@link #push} should call this method before exiting. Otherwise,
-         * the memory used by the thread cannot be reclaimed. However, this is
-         * only necessary if not all calls to {@link #push} are balanced with a
-         * call to {@link #pop}.
+         * push() should call this method before exiting. Otherwise,
+         * the memory used by the thread cannot be reclaimed. It is
+         * possible to omit this call if and only if each push() call
+         * is always paired with a pop() call (even in presence of
+         * thrown exceptions). Then the memory used by NDC will be
+         * returned by the last pop() call and a call to remove() will
+         * be no-op.
          */
         void remove();
 
@@ -245,7 +249,7 @@ namespace log4cplus {
          *
          * ensures that between the entry and exit of foo the depth of the
          * diagnostic stack is conserved.
-         *
+         * 
          * <b>Note:</b>  Use of the {@link NDCContextCreator} class will solve
          * this particular problem.
          *
@@ -253,27 +257,19 @@ namespace log4cplus {
          */
         void setMaxDepth(size_t maxDepth);
 
+        // Public ctor but only to be used by internal::DefaultContext.
+        NDC();
+
       // Dtor
-        ~NDC();
+        virtual ~NDC();
 
     private:
       // Methods
-        DiagnosticContextStack* getPtr();
-
-      // Data
-        DCMTK_LOG4CPLUS_THREAD_LOCAL_TYPE threadLocal;
+        DCMTK_LOG4CPLUS_PRIVATE static DiagnosticContextStack* getPtr();
 
       // Disallow construction (and copying) except by getNDC()
-        NDC();
         NDC(const NDC&);
         NDC& operator=(const NDC&);
-
-      // Friends
-#if defined (_MSC_VER)
-        friend DCMTK_LOG4CPLUS_EXPORT NDC& getNDC();
-#else
-        friend NDC& getNDC();
-#endif
     };
 
 
@@ -286,14 +282,29 @@ namespace log4cplus {
     /**
      * This is the internal object that is stored on the NDC stack.
      */
-    struct DCMTK_LOG4CPLUS_EXPORT DiagnosticContext {
+    struct DCMTK_LOG4CPLUS_EXPORT DiagnosticContext
+    {
       // Ctors
-        DiagnosticContext(const tstring& message, DiagnosticContext *parent);
-        DiagnosticContext(const tstring& message);
+        DiagnosticContext();
+        DiagnosticContext(const log4cplus::tstring& message,
+            DiagnosticContext const * parent);
+        DiagnosticContext(tchar const * message,
+            DiagnosticContext const * parent);
+        DiagnosticContext(const log4cplus::tstring& message);
+        DiagnosticContext(tchar const * message);
+        DiagnosticContext(DiagnosticContext const &);
+        DiagnosticContext & operator = (DiagnosticContext const &);
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_RVALUE_REFS)
+        DiagnosticContext(DiagnosticContext &&);
+        DiagnosticContext & operator = (DiagnosticContext &&);
+#endif
+
+        void swap (DiagnosticContext &);
 
       // Data
-        tstring message; /*!< The message at this context level. */
-        tstring fullMessage; /*!< The entire message stack. */
+        log4cplus::tstring message; /*!< The message at this context level. */
+        log4cplus::tstring fullMessage; /*!< The entire message stack. */
     };
 
 
@@ -304,7 +315,8 @@ namespace log4cplus {
     class DCMTK_LOG4CPLUS_EXPORT NDCContextCreator {
     public:
         /** Pushes <code>msg</code> onto the NDC stack. */
-        NDCContextCreator(const tstring& msg);
+        NDCContextCreator(const log4cplus::tstring& msg);
+        NDCContextCreator(tchar const * msg);
 
         /** Pops the NDC stack. */
         ~NDCContextCreator();
@@ -314,4 +326,4 @@ namespace log4cplus {
 } // end namespace dcmtk
 
 
-#endif // DCMTK__LO4CPLUS_NDC_HEADER_
+#endif // _LO4CPLUS_NDC_HEADER_
diff --git a/oflog/include/dcmtk/oflog/ntelogap.h b/oflog/include/dcmtk/oflog/ntelogap.h
index 074eaae..e9c78fe 100644
--- a/oflog/include/dcmtk/oflog/ntelogap.h
+++ b/oflog/include/dcmtk/oflog/ntelogap.h
@@ -1,9 +1,10 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    nteventlogappender.h
+// File:    ntelogap.h
 // Created: 4/2003
 // Author:  Michael CATANZARITI
 //
-// Copyright 2003-2009 Michael CATANZARITI
+// Copyright 2003-2010 Michael CATANZARITI
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -19,31 +20,34 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_NT_EVENT_LOG_APPENDER_HEADER_
-#define DCMTK__LOG4CPLUS_NT_EVENT_LOG_APPENDER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_NT_EVENT_LOG_APPENDER_HEADER_
+#define DCMTK_LOG4CPLUS_NT_EVENT_LOG_APPENDER_HEADER_
 
 #include "dcmtk/oflog/config.h"
-#include "dcmtk/oflog/appender.h"
 
-#if defined(_WIN32)
-#  if ! defined (DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG)
-#    error "Your platform does not support NT event log."
-#  else
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG)
+
+#include "dcmtk/oflog/appender.h"
+#include "dcmtk/oflog/config/windowsh.h"
 
 
 namespace dcmtk {
 namespace log4cplus {
 
     /**
-     * Appends log events to NT EventLog.
+     * Appends log events to NT EventLog. 
      */
     class DCMTK_LOG4CPLUS_EXPORT NTEventLogAppender : public Appender {
     public:
       // ctors
-        NTEventLogAppender(const tstring& server,
-                           const tstring& log,
-                           const tstring& source);
-        NTEventLogAppender(const helpers::Properties properties, tstring& error);
+        NTEventLogAppender(const log4cplus::tstring& server, 
+                           const log4cplus::tstring& log, 
+                           const log4cplus::tstring& source);
+        NTEventLogAppender(const log4cplus::helpers::Properties & properties);
 
       // dtor
         virtual ~NTEventLogAppender();
@@ -63,9 +67,9 @@ namespace log4cplus {
         void addRegistryInfo();
 
       // Data
-        tstring server;
-        tstring log;
-        tstring source;
+        log4cplus::tstring server;
+        log4cplus::tstring log;
+        log4cplus::tstring source;
         HANDLE hEventLog;
         SID* pCurrentUserSID;
 
@@ -79,5 +83,4 @@ namespace log4cplus {
 } // end namespace dcmtk
 
 #endif // DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG
-#endif // _WIN32
-#endif //DCMTK__LOG4CPLUS_NT_EVENT_LOG_APPENDER_HEADER_
+#endif //DCMTK_LOG4CPLUS_NT_EVENT_LOG_APPENDER_HEADER_
diff --git a/oflog/include/dcmtk/oflog/nullap.h b/oflog/include/dcmtk/oflog/nullap.h
index 10f743a..adfba0b 100644
--- a/oflog/include/dcmtk/oflog/nullap.h
+++ b/oflog/include/dcmtk/oflog/nullap.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    nullappender.h
+// File:    nullap.h
 // Created: 6/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,25 +21,29 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_NULL_APPENDER_HEADER_
-#define DCMTK__LOG4CPLUS_NULL_APPENDER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_NULL_APPENDER_HEADER_
+#define DCMTK_LOG4CPLUS_NULL_APPENDER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
-#include "dcmtk/oflog/helpers/property.h"
 
 
 namespace dcmtk {
 namespace log4cplus {
 
     /**
-     * Appends log events to a file.
+     * Appends log events to a file. 
      */
     class DCMTK_LOG4CPLUS_EXPORT NullAppender : public Appender {
     public:
       // Ctors
         NullAppender();
-        NullAppender(const helpers::Properties& properties, tstring& error);
+        NullAppender(const log4cplus::helpers::Properties&);
 
       // Dtor
         virtual ~NullAppender();
@@ -47,7 +52,7 @@ namespace log4cplus {
         virtual void close();
 
     protected:
-        virtual void append(const spi::InternalLoggingEvent& event);
+        virtual void append(const log4cplus::spi::InternalLoggingEvent& event);
 
     private:
       // Disallow copying of instances of this class
@@ -58,5 +63,5 @@ namespace log4cplus {
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_NULL_APPENDER_HEADER_
+#endif // DCMTK_LOG4CPLUS_NULL_APPENDER_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/oflog.h b/oflog/include/dcmtk/oflog/oflog.h
index 254ffb7..7f9829b 100644
--- a/oflog/include/dcmtk/oflog/oflog.h
+++ b/oflog/include/dcmtk/oflog/oflog.h
@@ -26,7 +26,9 @@
 #include "dcmtk/config/osconfig.h"    /* make sure OS specific configuration is included first */
 
 #include "dcmtk/oflog/logger.h"
+#include "dcmtk/oflog/logmacro.h"
 #include "dcmtk/ofstd/oftypes.h"
+#include "dcmtk/ofstd/ofaptr.h"
 #include "dcmtk/ofstd/ofconapp.h"
 
 #define OFLOG_TRACE(logger, msg) DCMTK_LOG4CPLUS_TRACE(logger, msg)
@@ -39,7 +41,7 @@
 /** simple wrapper around the "low-level" Logger object to make it easier to
  *  switch to a different system
  */
-class DCMTK_LOG4CPLUS_EXPORT OFLogger : private dcmtk::log4cplus::Logger
+class DCMTK_LOG4CPLUS_EXPORT OFLogger : public dcmtk::log4cplus::Logger
 {
 public:
     /** copy constructor
@@ -65,25 +67,6 @@ public:
         OFF_LOG_LEVEL = dcmtk::log4cplus::OFF_LOG_LEVEL
     };
 
-    /** check if the given log level was activated.
-     *  This can be used to check if a given log level is activated before
-     *  spending cpu time on generating a log message. The OFLOG_* macros use
-     *  this automatically, so you should never do something like:
-     *     if (myLogger.isEnabledFor(INFO_LOG_LEVEL))
-     *         OFLOG_INFO("Doing it like this is pointless);
-     *  @param ll the log level to check for
-     *  @return true if messages on this level won't be discarded
-     */
-    bool isEnabledFor(dcmtk::log4cplus::LogLevel ll) const {
-        return Logger::isEnabledFor(ll);
-    }
-
-    /// this function is only used internally by OFLOG_FATAL and friends
-    void forcedLog(dcmtk::log4cplus::LogLevel ll, const dcmtk::log4cplus::tstring& message,
-                   const char* file=NULL, int line=-1, const char* function=NULL) const {
-        Logger::forcedLog(ll, message, file, line, function);
-    }
-
     /** Get the logger's log level.
      *  One of the checks that isEnabledFor() does looks like this:
      *    if (getChainedLogLevel() < level)
@@ -93,13 +76,6 @@ public:
     LogLevel getChainedLogLevel() const {
         return OFstatic_cast(LogLevel, Logger::getChainedLogLevel());
     }
-
-    /** Set the logger's log level.
-     *  @param ll log level to which this logger is set.
-     */
-    void setLogLevel(dcmtk::log4cplus::LogLevel ll) {
-        Logger::setLogLevel(ll);
-    }
 };
 
 /** functions for initializing the logging system
diff --git a/oflog/include/dcmtk/oflog/socketap.h b/oflog/include/dcmtk/oflog/socketap.h
index c94f4da..c107782 100644
--- a/oflog/include/dcmtk/oflog/socketap.h
+++ b/oflog/include/dcmtk/oflog/socketap.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  LOG4CPLUS
-// File:    socketappender.h
+// File:    socketap.h
 // Created: 5/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,20 +21,33 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_SOCKET_APPENDER_HEADER_
-#define DCMTK__LOG4CPLUS_SOCKET_APPENDER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_SOCKET_APPENDER_HEADER_
+#define DCMTK_LOG4CPLUS_SOCKET_APPENDER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
 #include "dcmtk/oflog/helpers/socket.h"
-#include "dcmtk/oflog/helpers/syncprims.h"
+#include "dcmtk/oflog/thread/syncprim.h"
+#include "dcmtk/oflog/thread/threads.h"
 
 
-#define DCMTK_LOG4CPLUS_MAX_MESSAGE_SIZE (8*1024)
+namespace dcmtk
+{
+namespace log4cplus
+{
+ 
 
+#ifndef UNICODE
+    size_t const DCMTK_LOG4CPLUS_MAX_MESSAGE_SIZE = 8*1024;
+#else
+    size_t const DCMTK_LOG4CPLUS_MAX_MESSAGE_SIZE = 2*8*1024;
+#endif
 
-namespace dcmtk {
-namespace log4cplus {
 
     /**
      * Sends {@link spi::InternalLoggingEvent} objects to a remote a log server.
@@ -67,7 +81,7 @@ namespace log4cplus {
      *   then the rate of event production, then the client can only
      *   progress at the network rate. In particular, if the network link
      *   to the the server is down, the client will be blocked.
-     *
+     * 
      *   <li>On the other hand, if the network link is up, but the server
      *   is down, the client will not be blocked when making log requests
      *   but the log events will be lost due to server unavailability.
@@ -89,9 +103,9 @@ namespace log4cplus {
     class DCMTK_LOG4CPLUS_EXPORT SocketAppender : public Appender {
     public:
       // Ctors
-        SocketAppender(const tstring& host, int port,
-                       const tstring& serverName = tstring());
-        SocketAppender(const helpers::Properties & properties, tstring& error);
+        SocketAppender(const log4cplus::tstring& host, unsigned short port, 
+                       const log4cplus::tstring& serverName = tstring());
+        SocketAppender(const log4cplus::helpers::Properties & properties);
 
       // Dtor
         ~SocketAppender();
@@ -105,18 +119,17 @@ namespace log4cplus {
         virtual void append(const spi::InternalLoggingEvent& event);
 
       // Data
-        helpers::Socket socket;
-        tstring host;
-        int port;
-        tstring serverName;
+        log4cplus::helpers::Socket socket;
+        log4cplus::tstring host;
+        unsigned int port;
+        log4cplus::tstring serverName;
 
 #if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
-        class ConnectorThread;
+        class DCMTK_LOG4CPLUS_EXPORT ConnectorThread;
         friend class ConnectorThread;
 
         class DCMTK_LOG4CPLUS_EXPORT ConnectorThread
             : public thread::AbstractThread
-            , public helpers::LogLogUser
         {
         public:
             ConnectorThread (SocketAppender &);
@@ -145,15 +158,16 @@ namespace log4cplus {
 
     namespace helpers {
         DCMTK_LOG4CPLUS_EXPORT
-        SocketBuffer convertToBuffer(const spi::InternalLoggingEvent& event,
-                                     const tstring& serverName);
+        void convertToBuffer (SocketBuffer & buffer,
+            const log4cplus::spi::InternalLoggingEvent& event,
+            const log4cplus::tstring& serverName);
 
         DCMTK_LOG4CPLUS_EXPORT
-        spi::InternalLoggingEvent readFromBuffer(SocketBuffer& buffer);
+        log4cplus::spi::InternalLoggingEvent readFromBuffer(SocketBuffer& buffer);
     } // end namespace helpers
 
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_SOCKET_APPENDER_HEADER_
+#endif // DCMTK_LOG4CPLUS_SOCKET_APPENDER_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/spi/apndatch.h b/oflog/include/dcmtk/oflog/spi/apndatch.h
index ad7d9d5..95919d9 100644
--- a/oflog/include/dcmtk/oflog/spi/apndatch.h
+++ b/oflog/include/dcmtk/oflog/spi/apndatch.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    appenderattachable.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,21 +21,25 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_SPI_APPENDER_ATTACHABLE_HEADER_
-#define DCMTK__LOG4CPLUS_SPI_APPENDER_ATTACHABLE_HEADER_
+#ifndef DCMTK_LOG4CPLUS_SPI_APPENDER_ATTACHABLE_HEADER_
+#define DCMTK_LOG4CPLUS_SPI_APPENDER_ATTACHABLE_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
 #include "dcmtk/oflog/tstring.h"
 #include "dcmtk/oflog/helpers/pointer.h"
-//#include <vector>
+#include "dcmtk/ofstd/ofvector.h"
 
 namespace dcmtk {
 namespace log4cplus {
     // Forward Declarations
     typedef helpers::SharedObjectPtr<Appender> SharedAppenderPtr;
-    typedef OFList<SharedAppenderPtr> SharedAppenderPtrList;
-    typedef OFListIterator(SharedAppenderPtr) SharedAppenderPtrListIterator;
+    typedef OFVector<log4cplus::SharedAppenderPtr> SharedAppenderPtrList;
 
     namespace spi {
 
@@ -50,14 +55,14 @@ namespace log4cplus {
             virtual void addAppender(SharedAppenderPtr newAppender) = 0;
 
             /**
-             * Get all previously added appenders as an Enumeration.
+             * Get all previously added appenders as an Enumeration.  
              */
             virtual SharedAppenderPtrList getAllAppenders() = 0;
 
             /**
              * Get an appender by name.
              */
-            virtual SharedAppenderPtr getAppender(const tstring& name) = 0;
+            virtual SharedAppenderPtr getAppender(const log4cplus::tstring& name) = 0;
 
             /**
              * Remove all previously added appenders.
@@ -71,9 +76,9 @@ namespace log4cplus {
 
             /**
              * Remove the appender with the name passed as parameter from the
-             * list of appenders.
+             * list of appenders.  
              */
-            virtual void removeAppender(const tstring& name) = 0;
+            virtual void removeAppender(const log4cplus::tstring& name) = 0;
 
           // Dtor
             virtual ~AppenderAttachable() = 0;
@@ -83,5 +88,5 @@ namespace log4cplus {
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_SPI_APPENDER_ATTACHABLE_HEADER_
+#endif // DCMTK_LOG4CPLUS_SPI_APPENDER_ATTACHABLE_HEADER_
 
